## START: Set by rpmautospec
## (rpmautospec version 0.3.5)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Below definitions are used to deliver config files from a particular branch
# of c/image, c/common, c/storage vendored in all of Buildah, Podman and Skopeo.
# These vendored components must have the same version. If it is not the case,
# pick the oldest version on c/image, c/common, c/storage vendored in
# Buildah/Podman/Skopeo.
%global image_branch  main
%global common_branch v%{version}
%global storage_branch main
%global shortnames_branch main

%global github_containers https://raw.githubusercontent.com/containers

Epoch: 5
Name: containers-common
Version: 0.57.1
Release: %autorelease
License: Apache-2.0
BuildArch: noarch
Summary: Common configuration and documentation for containers
BuildRequires: go-md2man
Provides: skopeo-containers = %{epoch}:%{version}-%{release}
Recommends: (container-selinux >= 2:2.162.1 if selinux-policy)
Recommends: fuse-overlayfs
Requires: (fuse-overlayfs if fedora-release-identity-server)
# SourceN files fetched from upstream
# GPG key and registry configs taken from RH
Source1: %{github_containers}/common/%{common_branch}/docs/containers.conf.5.md
Source2: %{github_containers}/common/%{common_branch}/pkg/config/containers.conf
Source3: %{github_containers}/common/%{common_branch}/pkg/seccomp/seccomp.json
Source4: %{github_containers}/common/%{common_branch}/pkg/subscriptions/mounts.conf
Source5: %{github_containers}/image/%{image_branch}/docs/containers-auth.json.5.md
Source6: %{github_containers}/image/%{image_branch}/docs/containers-certs.d.5.md
Source7: %{github_containers}/image/%{image_branch}/docs/containers-policy.json.5.md
Source8: %{github_containers}/image/%{image_branch}/docs/containers-registries.conf.5.md
Source9: %{github_containers}/image/%{image_branch}/docs/containers-registries.conf.d.5.md
Source10: %{github_containers}/image/%{image_branch}/docs/containers-registries.d.5.md
Source11: %{github_containers}/image/%{image_branch}/docs/containers-signature.5.md
Source12: %{github_containers}/image/%{image_branch}/docs/containers-transports.5.md
Source13: %{github_containers}/image/%{image_branch}/registries.conf
Source14: %{github_containers}/common/%{common_branch}/docs/containers-mounts.conf.5.md
Source15: %{github_containers}/shortnames/%{shortnames_branch}/shortnames.conf
Source16: %{github_containers}/image/%{image_branch}/default.yaml
Source17: %{github_containers}/image/%{image_branch}/default-policy.json
Source18: %{github_containers}/storage/%{storage_branch}/docs/containers-storage.conf.5.md
Source19: %{github_containers}/storage/%{storage_branch}/storage.conf
Source20: RPM-GPG-KEY-redhat-release
Source21: registry.access.redhat.com.yaml
Source22: registry.redhat.io.yaml
Source23: %{github_containers}/common/%{common_branch}/docs/Containerfile.5.md
Source24: %{github_containers}/common/%{common_branch}/docs/containerignore.5.md
Source25: %{github_containers}/common/%{common_branch}/docs/links/.containerignore.5

%description
This package contains common configuration files and documentation for container
tools ecosystem, such as Podman, Buildah and Skopeo.

It is required because the most of configuration files and docs come from projects
which are vendored into Podman, Buildah, Skopeo, etc. but they are not packaged
separately.

%package extra
Summary: Extra dependencies for Podman and Buildah
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: container-network-stack
Requires: oci-runtime
Recommends: crun
Requires: (crun if fedora-release-identity-server)
Recommends: netavark >= 1.6.0-1
Requires: (netavark >= 1.6.0-1 if fedora-release-identity-server)
Recommends: slirp4netns
Requires: (slirp4netns if fedora-release-identity-server)
Recommends: passt
Requires: (passt if fedora-release-identity-server)
Requires: iptables
Requires: nftables
Suggests: containernetworking-plugins >= 0.9.1-1
Recommends: qemu-user-static
Requires: (qemu-user-static-aarch64 if fedora-release-identity-server)
Requires: (qemu-user-static-arm if fedora-release-identity-server)
Requires: (qemu-user-static-x86 if fedora-release-identity-server)

%description extra
This subpackage will handle dependencies common to Podman and Buildah which are
not required by Skopeo.

%prep
cp %{SOURCE1} .
cp %{SOURCE2} .
cp %{SOURCE3} .
cp %{SOURCE4} .
cp %{SOURCE5} .
cp %{SOURCE6} .
cp %{SOURCE7} .
cp %{SOURCE8} .
cp %{SOURCE9} .
cp %{SOURCE10} .
cp %{SOURCE11} .
cp %{SOURCE12} .
cp %{SOURCE13} .
cp %{SOURCE14} .
cp %{SOURCE15} 000-shortnames.conf
cp %{SOURCE16} .
cp %{SOURCE17} policy.json
cp %{SOURCE18} .
cp %{SOURCE19} .
cp %{SOURCE20} .
cp %{SOURCE21} .
cp %{SOURCE22} .
cp %{SOURCE23} .
cp %{SOURCE24} .
cp %{SOURCE25} .

%if 0%{?rhel} <= 8
sed -i 's/log_driver = "journald"/#log_driver = "journald"/' containers.conf
%endif

%build
mkdir -p man5
for FILE in $(ls *.5.md); do
    go-md2man -in $FILE -out man5/$(basename $FILE .md)
done

cp man5/containerignore.5 man5/.containerignore.5

%install
# install config and policy files for registries
install -dp %{buildroot}%{_sysconfdir}/containers/{certs.d,oci/hooks.d,systemd}
install -dp %{buildroot}%{_sharedstatedir}/containers/sigstore
install -dp %{buildroot}%{_datadir}/containers/systemd
install -dp %{buildroot}%{_prefix}/lib/containers/storage
install -Dp -m0644 default.yaml -t %{buildroot}%{_sysconfdir}/containers/registries.d
install -Dp -m0644 storage.conf -t %{buildroot}%{_datadir}/containers
install -Dp -m0644 registries.conf -t %{buildroot}%{_sysconfdir}/containers
install -Dp -m0644 000-shortnames.conf -t %{buildroot}%{_sysconfdir}/containers/registries.conf.d
install -Dp -m0644 policy.json -t %{buildroot}%{_sysconfdir}/containers
# RPM-GPG-KEY-redhat-release already exists on rhel envs, install only on
# fedora and centos
%if 0%{?fedora} || 0%{?centos}
install -Dp -m0644 RPM-GPG-KEY-redhat-release -t %{buildroot}%{_sysconfdir}/pki/rpm-gpg
%endif
install -Dp -m0644 registry.access.redhat.com.yaml -t %{buildroot}%{_sysconfdir}/containers/registries.d
install -Dp -m0644 registry.redhat.io.yaml -t %{buildroot}%{_sysconfdir}/containers/registries.d


# install manpages
for FILE in $(ls -a man5 | grep 5); do
    install -Dp -m0644 man5/$FILE -t %{buildroot}%{_mandir}/man5
done

# install config files for mounts, containers and seccomp
install -m0644 mounts.conf %{buildroot}%{_datadir}/containers/mounts.conf
install -m0644 seccomp.json %{buildroot}%{_datadir}/containers/seccomp.json
install -m0644 containers.conf %{buildroot}%{_datadir}/containers/containers.conf

# install secrets patch directory
install -d -p -m 755 %{buildroot}/%{_datadir}/rhel/secrets
# rhbz#1110876 - update symlinks for subscription management
ln -s ../../../..%{_sysconfdir}/pki/entitlement %{buildroot}%{_datadir}/rhel/secrets/etc-pki-entitlement
ln -s ../../../..%{_sysconfdir}/rhsm %{buildroot}%{_datadir}/rhel/secrets/rhsm
ln -s ../../../..%{_sysconfdir}/yum.repos.d/redhat.repo %{buildroot}%{_datadir}/rhel/secrets/redhat.repo

%files
%dir %{_sysconfdir}/containers
%dir %{_sysconfdir}/containers/certs.d
%dir %{_sysconfdir}/containers/oci
%dir %{_sysconfdir}/containers/oci/hooks.d
%dir %{_sysconfdir}/containers/registries.conf.d
%dir %{_sysconfdir}/containers/registries.d
%dir %{_sysconfdir}/containers/systemd
%dir %{_prefix}/lib/containers/storage
%config(noreplace) %{_sysconfdir}/containers/policy.json
%config(noreplace) %{_sysconfdir}/containers/registries.conf
%config(noreplace) %{_sysconfdir}/containers/registries.conf.d/000-shortnames.conf
%if 0%{?fedora} || 0%{?centos}
%{_sysconfdir}/pki/rpm-gpg/RPM-GPG-KEY-redhat-release
%endif
%config(noreplace) %{_sysconfdir}/containers/registries.d/default.yaml
%{_sysconfdir}/containers/registries.d/registry.redhat.io.yaml
%{_sysconfdir}/containers/registries.d/registry.access.redhat.com.yaml
%ghost %{_sysconfdir}/containers/storage.conf
%ghost %{_sysconfdir}/containers/containers.conf
%dir %{_sharedstatedir}/containers/sigstore
%{_mandir}/man5/Containerfile.5.gz
%{_mandir}/man5/containerignore.5.gz
%{_mandir}/man5/.containerignore.5.gz
%{_mandir}/man5/containers*.5.gz
%dir %{_datadir}/containers
%dir %{_datadir}/containers/systemd
%{_datadir}/containers/storage.conf
%{_datadir}/containers/containers.conf
%{_datadir}/containers/mounts.conf
%{_datadir}/containers/seccomp.json
%dir %{_datadir}/rhel/secrets
%{_datadir}/rhel/secrets/*

%files extra

%changelog
* Fri Jan 05 2024 Lokesh Mandvekar <lsm5@redhat.com> - 5:0.57.1-1
- Use c/common upstream version for rpm with Epoch bump

* Sun Dec 10 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-101
- local build

* Thu Nov 09 2023 Brent Baude <bbaude@redhat.com> - 4:1-100
- Reverting zstd change to containers.conf

* Sun Nov 05 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-99
- Revert update.sh back to f39 version.

* Sun Nov 05 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-98
- local build

* Tue Oct 24 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-97
- local build

* Thu Sep 21 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-96
- local build

* Fri Aug 11 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-95
- local build

* Sat Jul 22 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-94
- local build

* Wed Jul 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 4:1-93
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sun Jul 09 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-92
- local build

* Sun Jul 02 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-91
- local build

* Wed Apr 12 2023 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-90
- extra subpackage depends netavark v1.6.0 or higher

* Mon Apr 10 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-89
- local build

* Mon Apr 10 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-88
- local build

* Tue Feb 21 2023 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-87
- Resolves: #2170856 - add passt dependency

* Tue Feb 14 2023 Dan Čermák <dan.cermak@cgc-instruments.com> - 4:1-86
- Switch License to SPDX

* Wed Feb 01 2023 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-85
- Suggests: qemu-user-static superseded by Recommends

* Tue Jan 31 2023 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-84
- adjust qemu-user-static dependencies in containers-common-extra

* Thu Jan 26 2023 Daniel J Walsh <dwalsh@redhat.com> - 4:1-83
- local build

* Thu Jan 19 2023 Fedora Release Engineering <releng@fedoraproject.org> - 4:1-82
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Wed Jan 04 2023 Alexander Larsson <alexl@redhat.com> - 4:1-81
- Add /etc/containers/systemd and /usr/share/containers/systemd dirs

* Thu Dec 15 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-80
- Change container-selinux to a recommends

* Wed Nov 02 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-79
- install RPM-GPG-KEY-redhat-release only on fedora and centos environments

* Thu Oct 06 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-78
- add cni-plugins and qemu-user-static deps to containers-common-extra

* Thu Oct 06 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-77
- both buildah and podman require iptables and nftables

* Thu Oct 06 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-76
- add containers-common-extra subpackage

* Wed Oct 05 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-75
- local build

* Tue Oct 04 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-74
- remove debbuild macros to comply with fedora guidelines

* Fri Sep 23 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-73
- deb envs probably need an explicit provides, whatevs

* Fri Sep 23 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-72
- obsolete and provide golang-github-containers-[common|image] =
  %%{epoch}:%%{version}-%%{release}

* Fri Sep 23 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-71
- obsolete golang-github-containers-common in debian and ubuntu

* Tue Sep 13 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-70
- local build

* Sun Sep 04 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-69
- local build

* Tue Aug 16 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-68
- Fix debbuild maintainer field issue

* Tue Aug 16 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-67
- debbuild package conflicts with golang-github-containers-common

* Wed Aug 10 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-66
- local build

* Wed Jul 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 4:1-65
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Thu Jul 14 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-64
- Update man pages and config files

* Wed Jul 13 2022 Jonathan Wakely <jwakely@fedoraproject.org> - 4:1-63
- Fix missing markup in Containerfile.5 man page

* Mon Jun 13 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-62
- Revert "skip RPM-GPG-KEY-redhat-release installation on non-centos RHEL"

* Mon Jun 13 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-61
- skip RPM-GPG-KEY-redhat-release installation on non-centos RHEL

* Tue May 31 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-60
- local build

* Fri May 27 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-59
- build deb packages using debbuild

* Thu May 12 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-58
- local build

* Tue Apr 26 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-57
- local build

* Thu Apr 14 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-56
- Update man pages and config files

* Wed Mar 23 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-55
- local build

* Tue Mar 15 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-54
- comment out log_driver for rhel8 on copr

* Mon Feb 14 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-53
- fix build - don't delete what doesn't exist

* Mon Feb 14 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-52
- temporarily remove dockerfile manpages

* Tue Feb 08 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-51
- update config files

* Thu Feb 03 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-50
- Revert "handle md2man dep for c9s"

* Thu Feb 03 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-49
- handle md2man dep for c9s

* Wed Feb 02 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-48
- Check for docker manpage existence in %%post

* Tue Feb 01 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-47
- resolve docker manpage conflicts

* Fri Jan 28 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-46
- no error if man5 exists

* Fri Jan 28 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-45
- install containerfile and dockerfile manpages

* Wed Jan 26 2022 Daniel J Walsh <dwalsh@redhat.com> - 4:1-44
- Update man pages and config files

* Mon Jan 24 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-43
- Depend on container-network-stack and switch to autospec

* Wed Jan 19 2022 Fedora Release Engineering <releng@fedoraproject.org> - 4:1-42
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Dec 20 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-41
- Update to grab latest man pages and configuration files

* Mon Nov 29 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-40
- Update to grab latest man pages and configuration files

* Mon Nov 08 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-39
- Update to grab latest man pages and configuration files

* Thu Oct 21 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-38
- Update to grab latest man pages and configuration files

* Thu Oct 07 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-37
- Update to grab latest man pages and configuration files

* Tue Oct 05 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-36
- Add .containerignore.5 link

* Fri Oct 01 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-35
- Update to grab latest man pages and configuration files

* Sun Sep 26 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-34
- Update to grab latest man pages and configuration files

* Mon Sep 20 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-33
- Update to grab latest man pages and configuration files

* Tue Sep 14 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-32
- Update to grab latest man pages and configuration files

* Wed Sep 08 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-31
- Update to grab latest man pages and configuration files

* Wed Aug 25 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-30
- Add memfd_secret to seccomp.json

* Thu Aug 12 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-29
- Update to grab latest man pages and configuration files

* Mon Jul 26 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-28
- Add support for signed RHEL images, enabled by default

* Mon Jul 26 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-27
- Add support for signed RHEL images, enabled by default

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 4:1-26
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Wed Jul 21 2021 Fedora Release Engineering <releng@fedoraproject.org> - 4:1-25
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Thu Jul 15 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-24
- Update to grab latest man pages and configuration files, also switch to
  using some main rather then master branches

* Tue Jun 29 2021 Lokesh Mandvekar <lsm5@fedoraproject.org> - 4:1-23
- containers-common-4:1-21
- fetch latest upstream configs

* Thu Jun 10 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-22
- Update to grab latest man pages and configuration files, also switch to
  using some main rather then master branches

* Thu Jun 10 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-21
- Update to grab latest man pages and configuration files, also switch to
  using some main rather then master branches

* Thu Jun 10 2021 Daniel J Walsh <dwalsh@redhat.com> - 4:1-20
- RPMAUTOSPEC: unresolvable merge
